function subp=init_weights(popsize, niche, objDim)
% Author: Asad Mohammadi
% Email : asadmoh1985@gmail.com
% --------
% License:
% --------
% This program is to be used under the terms of the GNU General Public License 
% (http://www.gnu.org/copyleft/gpl.html).
% Author: Asad Mohammadi
% Email : asadmoh1985@gmail.com
% Copyright notice: (c) 2014 Asad Mohammadi

    subp=[];
    if objDim == 2
        for i=1:popsize
                p=struct('weight',[],'neighbour',[],'optimal', Inf, 'optpoint',[], 'curpoint', []);
                weight=zeros(2,1);
                weight(1)=i/popsize;
                weight(2)=(popsize-i)/popsize;
                p.weight=weight;
                subp=[subp p];
        end
    elseif objDim==3
        H = (-3 + sqrt(1+8*popsize))/2;
        step = 1 / H;
        c1 = 0;
        c2 = 0;
        c3 = 0;
        while (abs(c1 + c2 + c3 - 3) > 1e-1)
           
            if (abs(c1 + c2 + c3 - 1) < 1e-10)
                p=struct('weight',[],'neighbour',[],'optimal', Inf, 'optpoint',[], 'curpoint', []);
                weight=zeros(3,1);
                weight(1) = c1;
                weight(2) = c2;
                weight(3) = c3;
                p.weight = weight;
                subp = [subp p];
                disp(sprintf('%f %f %f = %f\n', c1, c2, c3, sum([c1 ;c2; c3])));
            end

            c1 = c1 + step;
            if(abs(c1-1) <= 1e-10)
                c2 = c2 + step;
                if(abs(c2-1) <= 1e-10)
                    c3 = c3 + step;
                    if(abs(c3-1) > 1e-10)
                        c3 = mod(c3, 1);
                    end
                end
                c2 = mod(c2, 1);
            end
            c1 = mod(c1, 1);
        end        
    end

    
    

    leng=length(subp);
    distanceMatrix=zeros(leng, leng);
   niche=leng;
    for i=1:leng
        for j=i+1:leng
            A=subp(i).weight;
            B=subp(j).weight;
            distanceMatrix(i,j)=(A-B)'*(A-B);
            distanceMatrix(j,i)=distanceMatrix(i,j);
        end
        [s,sindex]=sort(distanceMatrix(i,:));
        subp(i).neighbour=sindex(1:niche)';
    end
   
end